import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.DataInputStream;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SpringLayout;
import javax.swing.border.EmptyBorder;

import lejos.pc.comm.NXTComm;
import lejos.pc.comm.NXTCommFactory;
import lejos.pc.comm.NXTInfo;

public class Main extends JFrame implements Runnable {

	private JPanel contentPane;
	private JButton btnConnetti;

	private DataInputStream dis;
	private JTextArea txtDati;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main frame = new Main();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Main() {
		setTitle("Prospezione");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		SpringLayout sl_contentPane = new SpringLayout();
		contentPane.setLayout(sl_contentPane);
		
		btnConnetti = new JButton("Connetti");
		btnConnetti.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				attivaComunicazione();
			}
		});
		sl_contentPane.putConstraint(SpringLayout.NORTH, btnConnetti, 0, SpringLayout.NORTH, contentPane);
		sl_contentPane.putConstraint(SpringLayout.WEST, btnConnetti, 0, SpringLayout.WEST, contentPane);
		contentPane.add(btnConnetti);
		
		JScrollPane scrollPane = new JScrollPane();
		sl_contentPane.putConstraint(SpringLayout.NORTH, scrollPane, 0, SpringLayout.NORTH, btnConnetti);
		sl_contentPane.putConstraint(SpringLayout.WEST, scrollPane, 6, SpringLayout.EAST, btnConnetti);
		sl_contentPane.putConstraint(SpringLayout.SOUTH, scrollPane, 0, SpringLayout.SOUTH, contentPane);
		sl_contentPane.putConstraint(SpringLayout.EAST, scrollPane, 0, SpringLayout.EAST, contentPane);
		contentPane.add(scrollPane);
		
		txtDati = new JTextArea();
		txtDati.setText("x (m)\th (m)\r\n");
		scrollPane.setViewportView(txtDati);
	}
	
	public void attivaComunicazione() {
		try {
			NXTComm nxtComm = NXTCommFactory.createNXTComm(NXTCommFactory.BLUETOOTH);
			NXTInfo[] nxtInfo = nxtComm.search("NXT");
			if (nxtInfo.length > 0)
				if (nxtComm.open(nxtInfo[0])) {
					btnConnetti.setEnabled(false);
					btnConnetti.setText("Connesso");
					dis = new DataInputStream(nxtComm.getInputStream());
					
					Thread thread = new Thread(this);
					thread.setDaemon(true);
					thread.start();
				}
				else {
					System.out.println("nessun dispositivo trovato");
				}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(this, "Impossibile stabilire la connesisone");
		}
	}
	
	@Override
	public void run() {
		boolean connected = true;
		while(connected) {
			try {
				
				double x=dis.readDouble();
				double h=dis.readDouble();   // NB l'altezza  in cm: convertirla in m
				txtDati.append(x + "\t" + h/100.0 + "\n");
			} catch (IOException e) {
				connected=false;
			}
		}
	}
	
}
